#ifndef PUBLIC_INCLUDED
#include "publicInc.h"
#endif
#define SESSION_INCLUDED


typedef enum
{
    conn_state_empty,	//not authed
    conn_state_authed,	//lobby status
    conn_state_game,		//status game
    conn_state_destroy	//status exited
} type_conn_state;



typedef struct key
{
	char 				userid[21];
	int				Len;
	short				flag;
	int				key;
	int				rmCnt;
	unsigned short	svridx;
}
type_key;




typedef struct partySystem
{
	unsigned char		flag;		//Ƽ  
	unsigned char		cnt;		//Ƽ ο

	short					memidx;		//ڽ ġ..
	unsigned short		infoFcnt;	//  ˸ īƮ..

	void		*			waitfor;		//ٸ ִ³ ȣ

	void		*			master;
	short					ison1;		//0:NULL 	1:linked		2:myself(member#==NULL)

	void		*			mem2;
	short					ison2;

	void		*			mem3;
	short					ison3;

}type_party;



typedef struct tradeSystem
{
	short					flag;					//Ʈ̵ 
	void				*	tg;
	short					confirm;

	unsigned char		itemidx[2];		//Ʈ̵ κ  尪 κ丮 ε
	unsigned short		invidx[2];		//ε
	unsigned short		cnt[2];			//īƮ
	unsigned int		coin;
}type_trade;



typedef struct connection
{
	char			  	 	userid[32];
	char			  	 	char_name[32];
	unsigned short  	uLen;
	unsigned short  	nLen;
	unsigned short  	userNo;
	int             	sock;
	unsigned short  	port;
	unsigned int    	addr;
	type_conn_state 	state;
	unsigned int    	sessionkey;
	unsigned int 		clientver;
	int					disco;

	unsigned char		dbLoaded;	//db load
	short					frameCnt;	// ī
	short					userStat;	// 0:stand 1:move 2:fight 3:trade
	short					roomNo;		//default:0


	/****ɸ ****/
	unsigned short		Cx;			//current loc x ġ
	unsigned short		Cy;			//current loc y
	unsigned short		Dx;			//destination x
	unsigned short		Dy;			//destination y

	short					Ax;			//current sector X
	short					Ay;			//current sector y
	short					Bx;			//before  sector X
	short					By;			//before  sector y

	char					race;
	char					sex;
	char					nation;

	unsigned short		str;		//
	unsigned short		dex;		//ø
	unsigned short		intel;	//

	unsigned short		attack;	//ݷ
	unsigned short		defence;	//

	unsigned short		hp_m;
	short					hp_c;
	short					mana_m;//ųݽ ..
	short					mana_c;

	unsigned int		exp;
	unsigned short		level;
	unsigned short		lvpoint;
	unsigned int		skexp;

	char					jobno;
	char					classno;
	char					classlevel;

	unsigned short 	worldmap;	//map index
	unsigned short		moveLevel; 	//ɸ  ...
	char					Dir;		//direction of destination(tile no.)

	/***** targetting ********/
	char					tgtype;
	short 				target_id;
	void			*		target;

	/**** item definition****/
	unsigned short		eq[7];//迭

	/**** inventory definition****/
	unsigned short		inven[4];//κ丮 4
	unsigned char		inven_cnt[4];//κ丮 48

	/**** warehouse definition****/
	unsigned short		ware[8];//â 8
	unsigned char		ware_cnt[8];//â 8

	/**** skill definition.****/
	unsigned short		skill[4];
	unsigned char		skill_lv[4];

	unsigned int 		coin; //

	char					move_F_cnt;
	unsigned short		mana_F_cnt;// ȸ ī..
	unsigned short		recov_F_cnt;// ȸ ī..
	short					attack_F_cnt;// ݵ̿ ī..
	short					regen_F_cnt;
	unsigned int		dbSaveCnt;

	unsigned char		pkmode;
	type_party			party;
	type_trade			trade;
}
type_session;



typedef struct connArray
{
	type_session			s;
	int						sockNo;
	char						flag;
}
t_sessionArray;



extern type_session * session_create(int sock, unsigned int addr, unsigned short port);
extern void session_clear(type_session * c);

extern int session_set_userid(type_session * c, char * msg,int len);
extern int session_set_charname(type_session * c, char * msg,int len);

extern void init_t_sessionArray();
extern void reset_sessionArray(int idx);

extern type_session * ret_session(int idx);
extern type_session * ret_session_first(unsigned int max);
extern type_session * ret_session_next(unsigned int max);
extern type_session * ret_session_first2(unsigned int max);
extern type_session * ret_session_next2(unsigned int max);
extern short session_attack_chr(type_session * c,unsigned short Index,void * conn);
extern type_session * session_ret_session(unsigned short idx);

extern void session_init_keyArray();
extern int session_keynode_create(char * data, unsigned short svridx);
extern void session_key_clear(char * userid,int uLen);
extern void session_key_admin();
extern int session_key_cmp(char * userid,int uLen, unsigned int key);
